<template>
  <form class="container" @submit.prevent="">
    <formInput v-model="email" :errors="errors.email" icon="mdi:account" inputType="email" placeHolder="Email" autocomplete="email" />
    <formInput v-model="password" :errors="errors.password" icon="mdi:lock" inputType="password" placeHolder="Password" autocomplete="current-password" />
    <Button :onClick=submit :state="state" enabledText="Sign in" loadingText="Signing in..." successText="Signed in!" />
    <errorText :errors="errors.general" />
  </form>
  <div class="mt-2 text-center">
    <p> Don't have an account? <a href="/register">Register</a> </p>
  </div>
</template>
    
<script setup lang="ts">
import formInput from "./form-input.vue";
import errorText from './error-text.vue';
import Button, { type State } from './button.vue';
import { ref, type Ref } from 'vue';
import { delay } from '@/utils/helper';

const state: Ref<State> = ref("ENABLED");

const email = ref("");
const password = ref("");
const errors = ref({
  email: "",
  password: "",
  general: ""
});

const submit = async () => {
  resetError();

  if (!validInput())
    return;

  try {
    const body = { email: email.value, password: password.value };
    const response = await fetch("/api/auth/login", {
      method: "POST",
      headers: { "Content-Type": "application/json" },
      body: JSON.stringify(body)
    });

    if (response.ok) {
      state.value = "SUCCESS";
      await delay();
      window.location.href = "/";
      return;
    }

    await handleErrors(response);
  } catch (error) {
    // console.log(error);
    errors.value.general = "Something went wrong, please try again";
  }
};

function resetError() {
  errors.value = {
    email: "",
    password: "",
    general: ""
  };
}

function validInput(): boolean {
  const invalidEmail = email.value === "";
  const invalidPassword = password.value === "";
  if (invalidEmail) {
    errors.value.email = "Email is required";
  }
  if (invalidPassword) {
    errors.value.password = "Password is required";
  }
  if (invalidPassword || invalidEmail) {
    return false;
  }
  return true;
}

async function handleErrors(response: Response) {
  if (response.status === 400) {
    const message = (await response.json()).message;
    if (message.includes("password")) {
      errors.value.password = message;
      return;
    }
    if (message.includes("email")) {
      errors.value.email = message;
      return;
    }
  }

  if (response.status === 401) {
    errors.value.general = "Invalid login credentials";
    return;
  }

  if (response.status === 500) {
    errors.value.general = "Something went wrong, please try again";
    return;
  }
}
</script>